// EditListCtrl.cpp :  Դϴ.
//

#include "stdafx.h"
#include "EditListCtrl.h"


// CEditListCtrl

IMPLEMENT_DYNAMIC(CEditListCtrl, CListCtrl)

CEditListCtrl::CEditListCtrl()
: m_nItem(0), m_nSubItem(0)
, m_bInit(false)
, m_hFocus((HWND)0)
{

}

CEditListCtrl::~CEditListCtrl()
{
}

BEGIN_MESSAGE_MAP(CEditListCtrl, CListCtrl)
	ON_NOTIFY_REFLECT(NM_CLICK, &CEditListCtrl::OnNMClick)
END_MESSAGE_MAP()




// CEditListCtrl ޽ óԴϴ.

BOOL CEditListCtrl::PreTranslateMessage(MSG* pMsg)
{
	if(m_hFocus != (HWND)0)
	{
		HWND hFocus = ::GetFocus();

		// Edit  Focus .
		if(m_hFocus != hFocus)
		{
			OnOK();
		}
	}
	

	return CListCtrl::PreTranslateMessage(pMsg);
}

void CEditListCtrl::Init(void)
{
	if(m_bInit) return;

	SetExtendedStyle(LVS_EX_FULLROWSELECT | LVS_EX_GRIDLINES);
	::ShowWindow(_GetEditHwnd(), SW_HIDE);

	m_bInit = true;
}


// Return Ű  ȣϱ ..
void CEditListCtrl::OnOK(void)
{
	CWnd* pWnd = GetFocus();

	if(_GetEditHwnd() == pWnd->GetSafeHwnd() ||
		_GetEditHwnd() == m_hFocus)
	{
		// EditCtrl  Text ´.
		wchar_t cText[255];
		ZeroMemory(cText, 255);
		::GetWindowText(_GetEditHwnd(), cText, 255);
		CString cStrText(cText);

		//  ؽƮ ListCtrl  Ų
		if(SetText(cStrText, m_nItem, m_nSubItem) == FALSE)
			return;

		// EditCtrl Focus δ.
		::SendMessage(_GetEditHwnd(), WM_KILLFOCUS, 0, 0);
		::ShowWindow(_GetEditHwnd(), SW_HIDE);
		::SetFocus(pWnd->GetSafeHwnd());

		// ListCtrl SelectionMark Ѵ.
		SetSelectionMark(m_nItem);
	}

	m_hFocus = (HWND)0;
}

BOOL CEditListCtrl::SetText(CString _val, int _row, int _col)
{
	return SetItemText(_row, _col, _val);
}

void CEditListCtrl::OnNMClick(NMHDR *pNMHDR, LRESULT *pResult)
{
	Invalidate();

	LPNMITEMACTIVATE pNMITEM = (LPNMITEMACTIVATE) pNMHDR;
	m_nItem = pNMITEM->iItem;
	m_nSubItem = pNMITEM->iSubItem;

	// õ  ùٸ ...
	if(m_nSubItem == 0 || m_nSubItem == -1 || m_nItem == -1)
		return;

	// õ SubItem Text CEdit  ־ֱ  
	CString cStrText = GetItemText(m_nItem, m_nSubItem);

	CRect rtSubItem, rtListCtrl, rtDlg;
	// SubItem  Rect ´.
	if(GetSubItemRect(pNMITEM->iItem, pNMITEM->iSubItem, LVIR_BOUNDS, rtSubItem) == FALSE)
		return;

	// ListControl  Window Bounds  ´.
	::GetWindowRect(_GetListHwnd(), &rtListCtrl);

	// Parent Dialog  Windows Bounds  ´.
	::GetWindowRect(_GetParentHwnd(), &rtDlg);

	// Dialog ġ ListCtrl left & top ġ Ѵ.
	int nThisLeft = rtListCtrl.left - rtDlg.left;
	int nThisTop = rtListCtrl.top - rtDlg.top;

	// EditCtrl ġ ش.
	::SetWindowPos(
		_GetEditHwnd(), 
		HWND_TOP,
		nThisLeft + rtSubItem.left + 7,
		nThisTop + rtSubItem.top + 4,
		rtSubItem.Width() - 7,
		rtSubItem.Height() - 4,
		NULL);

	// EditCtrl Show
	::ShowWindow(_GetEditHwnd(), SW_SHOW);
	::SetFocus(_GetEditHwnd());

	// SubItem ġ ܰ ׷ش.
	::Rectangle(::GetDC(_GetListHwnd()), rtSubItem.left, rtSubItem.top - 1, rtSubItem.right, rtSubItem.bottom);

	// EditCtrl   List Text  ־ش.
	::SetWindowText(_GetEditHwnd(), cStrText);

	//  Text  Ŀ ְ MarkѴ.
	int nSel = cStrText.GetLength();
	::SendMessage(_GetEditHwnd(), EM_SETSEL, LOWORD(nSel), HIWORD(nSel));

	// Focus Ҿ  ListCtrl Ű  
	m_hFocus = _GetEditHwnd();
	Invalidate();

	*pResult = 0;
}


HWND CEditListCtrl::_GetEditHwnd(void)
{
	return ::GetDlgItem(GetParent()->GetSafeHwnd(), IDC_EDIT_CAM_ATTR);
}

HWND CEditListCtrl::_GetListHwnd(void)
{
	return GetSafeHwnd();
}

HWND CEditListCtrl::_GetParentHwnd(void)
{
	return GetParent()->GetSafeHwnd();
}
